## ros-melodic-hector-gazebo-plugins 0.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(hector_gazebo_plugins)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS roscpp std_msgs std_srvs geometry_msgs nav_msgs tf dynamic_reconfigure message_generation)
include_directories(include ${catkin_INCLUDE_DIRS})

## Find gazebo
find_package(gazebo REQUIRED)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GAZEBO_CXX_FLAGS}")
include_directories(${GAZEBO_INCLUDE_DIRS})
link_directories(${GAZEBO_LIBRARY_DIRS})

## Find Boost
find_package(Boost REQUIRED COMPONENTS thread)
include_directories(${Boost_INCLUDE_DIRS})

#######################################
## Declare ROS messages and services ##
#######################################

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
# )

## Generate services in the 'srv' folder
add_service_files(
  FILES
  SetBias.srv
)

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES geometry_msgs
)

#add dynamic reconfigure api
generate_dynamic_reconfigure_options(
  cfg/SensorModel.cfg
  cfg/GNSS.cfg
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
    CATKIN_DEPENDS roscpp std_msgs geometry_msgs nav_msgs tf message_runtime
    INCLUDE_DIRS include
    LIBRARIES
)

###########
## Build ##
###########

add_library(diffdrive_plugin_6w src/diffdrive_plugin_6w.cpp)
target_link_libraries(diffdrive_plugin_6w ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(diffdrive_plugin_multi_wheel src/diffdrive_plugin_multi_wheel.cpp)
target_link_libraries(diffdrive_plugin_multi_wheel ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(gazebo_ros_force_based_move src/gazebo_ros_force_based_move.cpp)
target_link_libraries(gazebo_ros_force_based_move ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(hector_gazebo_reset_plugin src/reset_plugin.cpp)
target_link_libraries(hector_gazebo_reset_plugin ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(hector_gazebo_ros_imu src/gazebo_ros_imu.cpp)
target_link_libraries(hector_gazebo_ros_imu ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_imu ${PROJECT_NAME}_generate_messages_cpp ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_magnetic src/gazebo_ros_magnetic.cpp)
target_link_libraries(hector_gazebo_ros_magnetic ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_magnetic ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_gps src/gazebo_ros_gps.cpp)
target_link_libraries(hector_gazebo_ros_gps ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_gps ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_sonar src/gazebo_ros_sonar.cpp)
target_link_libraries(hector_gazebo_ros_sonar ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_sonar ${PROJECT_NAME}_gencfg)

add_library(hector_servo_plugin src/servo_plugin.cpp)
target_link_libraries(hector_servo_plugin ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS
  diffdrive_plugin_6w
  diffdrive_plugin_multi_wheel
  gazebo_ros_force_based_move
  hector_gazebo_reset_plugin
  hector_gazebo_ros_imu
  hector_gazebo_ros_magnetic
  hector_gazebo_ros_gps
  hector_gazebo_ros_sonar
  hector_servo_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-melodic-hector-gazebo-plugins (0.5.1-0stretch) stretch; urgency=high

  * Merge pull request #44 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/44> from esteve/gazebo8
    Use Gazebo 8 APIs to avoid deprecation warnings.
  * Fix indent
  * Depend on gazebo_dev instead
  * Use sdf::Time to read time periods from SDF files.
  * Only include math headers when building for Gazebo < 8
  * Use Gazebo 8 APIs to avoid deprecation warnings.
  * Merge pull request #36 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/36> from vincentrou/get_fix_status
    [gazebo_plugins] Ensure to get gps fix status as an int in urdf
  * hector_gazebo_plugins: numeric conversion of NavSatFix status and service from SDF without std::stoi
  * [gazebo_plugins] Ensure to get gps fix status as an int
  * hector_gazebo_plugins/hector_gazebo_thermal_camera: removed catkin_package(DEPENDS gazebo) declaration which was a no-op anyway
    See https://github.com/ros-simulation/gazebo_ros_pkgs/pull/537.
  * Contributors: Esteve Fernandez, Johannes Meyer, Vincent Rousseau

 -- Johannes Meyer <johannes@intermodalics.eu>  Thu, 28 Jun 2018 22:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.5.0-0stretch) stretch; urgency=high

  * Updated gazebo dependencies to version 7 for kinetic release
  * Contributors: Johannes Meyer

 -- Johannes Meyer <johannes@intermodalics.eu>  Thu, 23 Jun 2016 22:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.4.1-0stretch) stretch; urgency=high

  * see 0.3.8

 -- Johannes Meyer <johannes@intermodalics.eu>  Thu, 23 Jun 2016 22:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.4.0-0stretch) stretch; urgency=high

  * Added proper dependencies for jade and gazebo5. Now compiles and works for gazebo5
  * Contributors: L0g1x

 -- Johannes Meyer <johannes@intermodalics.eu>  Fri, 06 Nov 2015 23:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.3.8-0stretch) stretch; urgency=high

  * hector_gazebo_plugins: fixed angular rate output with non-zero rpyOffset parameter (fix #23)
  * Fix compilation errors and warnings against Gazebo 7
  * Fix
  * Compatible with gazebo7
  * [hector_gazebo_plugins] fix missing dependencies
  * Update odometry with proper covariance data
  * Updates to 2d odom
  * Basics of 2d odom
  * Add gitignore
  * Add Cmake flags for C++11
  * Make force based p gains parameters
  * Contributors: Furushchev, Johannes Meyer, Nate Koenig, Nicolae Rosia, Romain Reignier, Stefan Kohlbrecher

 -- Johannes Meyer <johannes@intermodalics.eu>  Thu, 23 Jun 2016 22:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.3.7-0stretch) stretch; urgency=high

  * gazebo_ros_force_based_move: Disable odom tf publishing if set in sdf params
  * gazebo_ros_force_based_move: Add plugin for applying forces based on cmd_vel input (allows simulation of tracked vehicles)
  * hector_gazebo_plugins/hector_gazebo_thermal_camera: switch to cmake configuration for gazebo and added OGRE include directories required for CameraPlugin.hh
  * Contributors: Johannes Meyer, kohlbrecher

 -- Johannes Meyer <johannes@intermodalics.eu>  Fri, 06 Nov 2015 23:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.3.6-0stretch) stretch; urgency=high

  * allow negative offsets in SensorModel dynamic_reconfigure config
  * fixed sporadic NaN values in gazebo_ros_imu's angular_velocity output (fix #20)
  * reintroduced orientation bias due to accelerometer and yaw sensor drift
    This orientation bias was removed in 74b21b7, but there is no need for this.
    The IMU can have a mounting offset and a bias error. To remove the bias error, set the accelerationDrift and yawDrift parameters to 0.
  * interpret parameters xyzOffset and rpyOffset as pure mounting offsets and not as induced by accelerometer bias (fix #18)
    Obviously the SDF conversion assumes that all sensor plugins interpret the <xyzOffset> and <rpyOffset> parameters in the same way as an
    additional sensor link which is connected with a static joint to the real parent frame. I was not aware that this is a requirement.
    hector_gazebo_ros_imu interpreted the roll and pitch part of <rpyOffset> as an orientation offset caused by a (small) accelerometer bias.
    This patch completely removes the bias error on the orientation output in the Imu message and the orientation quaternion in the bias message
    is set to zero.
  * Contributors: Johannes Meyer

 -- Johannes Meyer <johannes@intermodalics.eu>  Fri, 20 Mar 2015 23:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.3.5-0stretch) stretch; urgency=high

  * fixed simulated IMU calibration
  * fill position_covariance in sensor_msgs/NavSatFix message from position error model in gazebo_ros_gps (fix #17)
  * added dynamic_reconfigure servers to gps, magneto and sonar plugins
    The GPS plugin allows to configure the status and server flags in the output message,
    additionally to the error characteristics. This allows to simulate GPS dropouts.
  * added dynamic_reconfigure server for IMU sensor model parameters
  * fixed invocation of sensor model in gazebo_ros_imu and gazebo_ros_sonar to also respect the scale error
  * calculate angular rate from quaternion difference directly
    This seems to be numerically more stable and removes the jitter in the angular rate signal.
  * added initial bias
  * added bias publisher to gazebo_ros_imu
    ...to compare hector_pose_estimation estimates with ground truth.
    Also renamed heading to yaw in gazebo_ros_imu and updated pseudo AHRS orientation calculation.
  * added scale error to the sensor model and removed linearization in drift update
    The scale error is assumed to be constant and its value is loaded from the scaleError plugin parameter.
    The default scale error is 1.0 (no scale error).
    The value returned by the model is (real_value * scale_error) + offset + drift + noise.
  * fixed wrong calculation of reference earth magnetic field vector if declination!=0
  * Contributors: Johannes Meyer



=== debian/control ===
Source: ros-melodic-hector-gazebo-plugins
Section: misc
Priority: extra
Maintainer: Johannes Meyer <johannes@intermodalics.eu>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-gazebo-dev, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf
Homepage: http://ros.org/wiki/hector_gazebo_plugins
Standards-Version: 3.9.2

Package: ros-melodic-hector-gazebo-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo7, ros-melodic-dynamic-reconfigure, ros-melodic-gazebo-ros, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf
Description: hector_gazebo_plugins provides gazebo plugins from Team Hector.
 Currently it contains a 6wd differential drive plugin, an IMU sensor plugin, an earth magnetic field sensor plugin, a GPS sensor plugin and a sonar ranger plugin.

## ros-melodic-hector-gazebo-plugins 0.5.4

=== debian/changelog ===
ros-melodic-hector-gazebo-plugins (0.5.4-1bionic) bionic; urgency=high

  * Added missing generate_message_cpp dependancy
  * Add service to gazebo gps sensor to set reference geopose
  * Add parameter to enable fetching the spherical coordinates from the world. (#83 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/83>)
    * Use worlds spherical_coordinates for GPS/magnetic reference
    This modifies GPS and magnetic plugins to use the values from the spherical_coordinates element of the world SDF as default values for the latitude, longitude, altitude and heading references.
    The optional parameters can still overwrite this values. However it is important to notice, that the heading in the world SDF is specified counter-clockwise from east whereas the reference_heading
    parameter is specified is specified clockwise from north.
    * Update spherical coordinates calls.
    * Add parameter to enable fetching the spherical coordinates from the world.
    This extends #47 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/47> with the addition of a "useWorldSphericalCoordinates" parameter
    that must be present and set to true to allow using the world's coordinates.
    This should solve #15 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/15> while addressing the concerns in #47 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/47>.
    Co-authored-by: Jacob Seibert <mailto:jacob.seibert@enway.ai>
  * Contributors: Ferry Schoenmakers, Roland Arsenault, h-wata

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Wed, 23 Jun 2021 00:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.5.3-1bionic) bionic; urgency=high

  * Updated CMake version and fixed CMP0048 for non-metapackages.
  * Merge branch 'kinetic-devel' into melodic-devel
  * Adjust licenses to be consistent with cpp files and plugins used in gazebo_ros_pkgs
  * Updated package format and maintainer information.
  * Contributors: Stefan Fabian, Stefan Kohlbrecher

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Wed, 03 Feb 2021 00:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.5.2-1bionic) bionic; urgency=high

  * Add case for rotating in place in odometry (#75 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/75>)
    * Add case for rotating in place in odometry
    Odometry calculations were not taking in account the case of the robot rotating in place. This
    would cause a division by zero and make the plugin return invalid data. This commit handles this
    case by not using the arc method if the distance traveled by the robot is close to zero.
    * Fix negative Y-axis motion bug
    Only the displacement along X and the combined displacement were used to
    calculate the angle between the X-axis and the robot drive direction.
    This resulted in a positive angle whatever if the displacement along Y
    was positive or negative. This commit addresses the issue by using both
    displacements along X and Y to calculate the angle.
  * Allow publishing sensor_msgs/MagneticField (#73 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/73>)
    Add a new useMagneticFieldMsgs parameter to the magnetometer plugin, allowing the node to publish sensor_msgs/MagneticField messages instead of std_msgs/Vector3Stamped
  * Add support of holonomic robot by adding missing Y component in odometry (#71 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/71>)
    * Add support of holonomic robot by adding missing Y component in odometry
    The odometry was only computed taking in account linear velocity on the x-axis and angular
    velocity around the z-axis. The code is modified to include linear velocity on the y-axis for
    support of holonomic robots. Odometry arc and radius are calculated the same way as before but
    using the combined linear velocity instead. The end position is then rotated by the angle between
    the combined velocity vector and the x-axis
    * Change variable name
    * Rename combined velocity angle variable
  * Merge pull request #64 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/64> from ms-iot/upstream_windows_fix
    [Windows][melodic-devel] Follow catkin guide to update the install path
  * fix install path. (#1 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/1>)
  * Merge pull request #53 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/53> from enwaytech/ml/cmp0054_fix
    add CMP0045 cmake policy before gazebo include in CMakeLists.txt
  * add CMP0045 cmake policy before gazebo include in CMakeLists.txt
  * Contributors: Chris I-B, Johannes Meyer, Matthias Loebach, RobinB, Sean Yen, Stefan Fabian

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Thu, 17 Dec 2020 00:00:00 -0000

ros-melodic-hector-gazebo-plugins (0.5.1-1bionic) bionic; urgency=high

  * Merge pull request #44 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/44> from esteve/gazebo8
    Use Gazebo 8 APIs to avoid deprecation warnings.
  * Fix indent
  * Depend on gazebo_dev instead
  * Use sdf::Time to read time periods from SDF files.
  * Only include math headers when building for Gazebo < 8
  * Use Gazebo 8 APIs to avoid deprecation warnings.
  * Merge pull request #36 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/36> from vincentrou/get_fix_status
    [gazebo_plugins] Ensure to get gps fix status as an int in urdf
  * hector_gazebo_plugins: numeric conversion of NavSatFix status and service from SDF without std::stoi
  * [gazebo_plugins] Ensure to get gps fix status as an int
  * hector_gazebo_plugins/hector_gazebo_thermal_camera: removed catkin_package(DEPENDS gazebo) declaration which was a no-op anyway
    See https://github.com/ros-simulation/gazebo_ros_pkgs/pull/537.
  * Contributors: Esteve Fernandez, Johannes Meyer, Vincent Rousseau

 -- Johannes Meyer <johannes@intermodalics.eu>  Fri, 29 Jun 2018 00:00:00 -0000



=== debian/control ===
Source: ros-melodic-hector-gazebo-plugins
Section: misc
Priority: optional
Maintainer: Stefan Fabian <fabian@sim.tu-darmstadt.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-gazebo-dev, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf
Homepage: http://ros.org/wiki/hector_gazebo_plugins
Standards-Version: 3.9.2

Package: ros-melodic-hector-gazebo-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo9, ros-melodic-dynamic-reconfigure, ros-melodic-gazebo-ros, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf
Description: hector_gazebo_plugins provides gazebo plugins from Team Hector.
 Currently it contains a 6wd differential drive plugin, an IMU sensor plugin, an earth magnetic field sensor plugin, a GPS sensor plugin and a sonar ranger plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-hector-gazebo-plugins//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
